%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/rhq/%{name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define project_version 3.0.0.EmbJopr4
Name:           rhq-jmx-plugin
Version:        3.0.0
Release:        20.EmbJopr4%{?dist}
Epoch:          0
Summary:        RHQ JMX Plugin
Group:          Development/Libraries
License:        ASL 2.0
URL:            http://www.rhq-project.org/display/RHQ/Plugins+-+Plugin+-+JMX
# git clone git://git.fedorahosted.org/rhq/rhq.git
# cd rhq
# git checkout RHQ_3_0_0_EmbJopr4
# git checkout -b RHQ_3_0_0_EmbJopr4
# cd modules/plugins/jmx
# tar zcf rhq-jmx-plugin-3.0.0.EmbJopr4.tar.gz .
Source0:        %{name}-%{project_version}.tar.gz
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Source3:        %{name}-component-info.xml
#Source6:        %{name}-rhq.tar.gz
#Source8:        %{name}-jboss-embeddable-ejb3-hibernate-all.tar.gz
#Patch0:         %{name}-rhq-parent-pom.patch
#Patch2:         %{name}-rhq-core-native-system-no-sigar-dist.patch
#Patch3:         %{name}-rhq-core-plugin-container-no-augeas.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils 
Requires:      hibernate3-ejb-persistence-3.0-api
Requires:      java
Requires:      jpackage-utils

# The plugin includes any JARs it needs, or they are expected to 
# be in the container, and in any case, it does no link to any JARs
# so there is no reason to have any of these Requires whatsoever
%if 0
Requires:      testng
Requires:      sigar
Requires:      org-mc4j-ems
Requires:      augeas
Requires:  sigar
Requires:  org-mc4j-ems >= 0:1.2.15.1
Requires:  rhq-common-parent
Requires:  rhq-core-domain
Requires:  rhq-core-parent
Requires:  rhq-core-util
Requires:  rhq-modules-parent
Requires:  rhq-core-client-api
Requires:  rhq-core-gui
Requires:  rhq-core-plugin-api
Requires:  rhq-jboss-as-common
Requires:  rhq-parent
Requires:  rhq-core-comm-api
Requires:  rhq-core-native-system
Requires:  rhq-core-plugin-container
Requires:  rhq-plugins-parent
%endif

BuildRequires:  java-devel >= 1:1.6.0
BuildRequires:  jpackage-utils
BuildRequires:  maven2 >= 0:2.0.4-9
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-ejb
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-plugin-ear
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven-scm
BuildRequires:  mojo-maven2-plugin-build-helper
BuildRequires:  mojo-maven2-plugin-exec
BuildRequires:  mojo-maven2-plugin-properties
BuildRequires:  mojo-maven2-plugin-buildnumber
BuildRequires:  hibernate3-ejb-persistence-3.0-api
BuildRequires:  testng
BuildRequires:  sigar
BuildRequires:  org-mc4j-ems >= 0:1.2.15.1
BuildRequires:  rhq-common-parent
BuildRequires:  rhq-core-domain
BuildRequires:  rhq-core-parent
BuildRequires:  rhq-core-util
BuildRequires:  rhq-modules-parent
BuildRequires:  rhq-core-client-api
BuildRequires:  rhq-core-gui
BuildRequires:  rhq-core-plugin-api
BuildRequires:  rhq-jboss-as-common
BuildRequires:  rhq-parent
BuildRequires:  rhq-core-comm-api
BuildRequires:  rhq-core-native-system
BuildRequires:  rhq-core-plugin-container
BuildRequires:  rhq-plugins-parent
BuildRequires:  hibernate3
BuildRequires:  hibernate3-ejb-persistence-3.0-api
BuildRequires:  hibernate3-annotations
BuildRequires:  i18nlog
BuildRequires:	jboss-parent
BuildRequires:	jboss-javaee
BuildRequires:  hsqldb
BuildRequires:  slf4j
BuildRequires:  jaxb_2_1_api
BuildRequires:  glassfish-jaxb
BuildRequires:  stax_1_0_api

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
A plugin to support management of JMX MBean Servers via various remoting systems

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q  -c %{name}

export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL
pushd $MAVEN_REPO_LOCAL
#tar zxf %{SOURCE6}
#tar zxf %{SOURCE8}
#%patch0 -b .sav
#%patch2 -b .sav
#%patch3 -b .sav
popd

cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp \
        -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.test.skip=true\
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Penterprise,dist,prod \
        -Ddbsetup-do-not-check-schema=true \
        install javadoc:javadoc

ls -lR target

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}
install -p -m 644 target/%{name}-%{project_version}.jar   %{buildroot}%{_javadir}/%{name}-%{project_version}.jar

(cd %{buildroot}%{_javadir} && for jar in *-%{project_version}*; \
    do ln -s ${jar} `echo $jar| sed "s|-%{project_version}||g"`; done)

%add_to_maven_depmap org.rhq %{name} %{project_version} JPP %{name}

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{version}-brew`
%{__sed} -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{project_version}.jar %{buildroot}%{repodirlib}/rhq-jmx-plugin.jar
%{__cp} -p pom.xml %{buildroot}%{repodirlib}/rhq-jmx-plugin.pom
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Oct 18 2011 Danesh Mondegarian <dmondega@redhat.com> 3.0.0-20.EmbJopr4
- Update to embjopr 4

* Wed Sep 28 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> 3.0.0-20.EmbJopr3
- Remove javadoc and repolib builds from main rpm

* Fri Sep 09 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> 3.0.0-19.EmbJopr3
- Rebuild 

* Thu Aug 04 2011 Tom Hauser <thauser@redhat.com> 3.0.0-18.EmbJopr3 
- Add entry to m2-settings.xml for signed jars repo

* Thu Aug 04 2011 Tom Hauser <thauser@redhat.com> 3.0.0-17.EmbJopr3 
- Rebuild

* Thu Aug 04 2011 Tom Hauser <thauser@redhat.com> 3.0.0-16.EmbJopr3
- Rebuild to get signed jars in priority over unsigned (JBPAPP-6676)

* Tue May 17 2011 Thomas Hauser <thauser@redhat.com> 3.0.0-15.EmbJopr3
- Rebuild

* Fri Apr 22 2011 Yong Yang <yyang@redhat.com> 3.0.0-14.EmbJopr3
- Fix source0 name
- Upgrade to EmbJopr3
- BR jaxb_2_1_api, glassfish-jaxb

* Mon Dec 06 2010 Yong Yang <yyang@redhat.com> 3.0.0-13.EmbJopr2
- Remove binary source jboss-embeddable-ejb3-hibernate-all.tar.gz
- add repolib

* Wed Sep 15 2010 Fernando Nasser <fnasser@redhat.com> 3.0.0-12.EmbJopr2
- Remove spurious Requires
- Add missing BR

* Mon Sep 06 2010 Yong Yang <yyang@redhat.com> 3.0.0-11.EmbJopr2
- Add missing Requires

* Sun Sep 05 2010 Yong Yang <yyang@redhat.com> 3.0.0-10.EmbJopr2
- Build with rhq package

* Wed Sep 01 2010 David Walluck <dwalluck@redhat.com> 3.0.0-9.EmbJopr2
- rebuild for org-mc4j-ems

* Wed Sep 01 2010 David Walluck <dwalluck@redhat.com> 3.0.0-8.EmbJopr2
- rebuild to ensure org-mc4j-ems version

* Thu Aug 26 2010 Martha Benitez <mbenitez@redhat.com> - 3.0.0-7.EmbJopr2
- Comment R org-mc4j-ems, sigar, testng

* Sat Aug 21 2010 Yong Yang <yyang@redhat.com> 3.0.0-6.EmbJopr2
- Upgrade to 3.0.0.EmbJopr2

* Wed Aug 11 2010 Yong Yang <yyang@redhat.com> 3.0.0-5.EmbJopr
- Update rhq.tar.gz

* Wed Aug 11 2010 Yong Yang <yyang@redhat.com> 3.0.0-4.EmbJopr
- Fix groupId of depmap

* Tue Aug 10 2010 Yong Yang <yyang@redhat.com> 3.0.0-3.EmbJopr
- Remove unnecessary sources

* Tue Aug 10 2010 Yong Yang <yyang@redhat.com> 3.0.0-2.EmbJopr
- Upgrade to 3.0.0.EmbJopr

* Thu Aug 05 2010 Yong Yang <yyang@redhat.com> 3.0.0-1.B06
- Initial build
